tensor_basic< T >

## Public Types

typedef size_t | size_type
typedef T | element_type
typedef T | float_type

## Public Member Functions

| tensor_basic (const T &init_val=0)
| tensor_basic (T x[3][3])
| tensor_basic (const tensor_basic< T > &a)
| tensor_basic (const std::initializer_list< std::initializer_list< T > > &il)
tensor_basic< T > & | operator= (const tensor_basic< T > &a)
tensor_basic< T > & | operator= (const T &val)
void | fill (const T &init_val)
void | reset ()
void | set_row (const point_basic< T > &r, size_t i, size_t d=3)
void | set_column (const point_basic< T > &c, size_t j, size_t d=3)
T & | operator() (size_type i, size_type j)
const T & | operator() (size_type i, size_type j) const
point_basic< T > | row (size_type i) const
point_basic< T > | col (size_type i) const
size_t | nrow () const
size_t | ncol () const
std::ostream & | put (std::ostream &s, size_type d=3) const
std::istream & | get (std::istream &)
bool | operator== (const tensor_basic< T > &) const
bool | operator!= (const tensor_basic< T > &b) const
const tensor_basic< T > & | operator+ () const
tensor_basic< T > | operator- () const
tensor_basic< T > | operator+ (const tensor_basic< T > &b) const
tensor_basic< T > | operator- (const tensor_basic< T > &b) const
tensor_basic< T > | operator* (const tensor_basic< T > &b) const
tensor_basic< T > | operator* (const T &k) const
tensor_basic< T > | operator/ (const T &k) const
point_basic< T > | operator* (const point_basic< T > &) const
point_basic< T > | trans_mult (const point_basic< T > &x) const
tensor_basic< T > & | operator+= (const tensor_basic< T > &)
tensor_basic< T > & | operator-= (const tensor_basic< T > &)
tensor_basic< T > & | operator*= (const T &k)
tensor_basic< T > & | operator/= (const T &k)
T | determinant (size_type d=3) const
bool | is_symmetric (size_type d=3) const
point_basic< T > | eig (tensor_basic< T > &q, size_t dim=3) const
point_basic< T > | eig (size_t dim=3) const
point_basic< T > | svd (tensor_basic< T > &u, tensor_basic< T > &v, size_t dim=3) const

## Static Public Member Functions

static tensor_basic< T > | eye (size_type d=3)

## Public Attributes

T | _x [3][3]

## Detailed Description

### template<class T>
class rheolef::tensor_basic< T >

Definition at line 90 of file tensor.h.

## Member Typedef Documentation

## size_type

typedef size_t size_type

Definition at line 93 of file tensor.h.

## element_type

typedef T element_type

Definition at line 94 of file tensor.h.

## float_type

typedef T float_type

Definition at line 95 of file tensor.h.

## Constructor & Destructor Documentation

## tensor_basic() [1/4]

tensor_basic | ( | const T & | init_val = `0` | ) |

Definition at line 266 of file tensor.h.

## tensor_basic() [2/4]

tensor_basic | ( | T | x[3][3] | ) |

Definition at line 272 of file tensor.h.

## tensor_basic() [3/4]

tensor_basic | ( | const tensor_basic< T > & | a | ) |

Definition at line 279 of file tensor.h.

## tensor_basic() [4/4]

tensor_basic | ( | const std::initializer_list< std::initializer_list< T > > & | il | ) |

Definition at line 285 of file tensor.h.

## Member Function Documentation

## eye()

tensor_basic< T > eye | ( | size_type | d = `3` | ) |

static

Definition at line 443 of file tensor.h.

## operator=() [1/2]

tensor_basic< T > & operator= | ( | const tensor_basic< T > & | a | ) |

Definition at line 303 of file tensor.h.

## operator=() [2/2]

tensor_basic< T > & operator= | ( | const T & | val | ) |

Definition at line 312 of file tensor.h.

## fill()

void fill | ( | const T & | init_val | ) |

Definition at line 252 of file tensor.h.

## reset()

void reset

Definition at line 260 of file tensor.h.

## set_row()

void set_row | ( | const point_basic< T > & | r,
|  | size_t | i,
|  | size_t | d = `3`
| ) |  |

Definition at line 435 of file tensor.h.

## set_column()

void set_column | ( | const point_basic< T > & | c,
|  | size_t | j,
|  | size_t | d = `3`
| ) |  |

Definition at line 427 of file tensor.h.

## operator()() [1/2]

T & operator() | ( | size_type | i,
|  | size_type | j
| ) |  |

Definition at line 335 of file tensor.h.

## operator()() [2/2]

const T & operator() | ( | size_type | i,
|  | size_type | j
| ) |  | const

Definition at line 342 of file tensor.h.

## row()

point_basic< T > row | ( | size_type | i | ) | const

Definition at line 313 of file tensor.cc.

## col()

point_basic< T > col | ( | size_type | i | ) | const

Definition at line 323 of file tensor.cc.

## nrow()

size_t nrow

Definition at line 321 of file tensor.h.

## ncol()

size_t ncol

Definition at line 328 of file tensor.h.

## put()

ostream & put | ( | std::ostream & | s,
|  | size_type | d = `3`
| ) |  | const

Definition at line 37 of file tensor.cc.

## get()

istream & get | ( | std::istream & | in | ) |

Definition at line 51 of file tensor.cc.

## operator==()

bool operator== | ( | const tensor_basic< T > & | b | ) | const

Definition at line 101 of file tensor.cc.

## operator!=()

bool operator!= | ( | const tensor_basic< T > & | b | ) | const

Definition at line 135 of file tensor.h.

## operator+() [1/2]

const tensor_basic<T>& operator+ | ( |  | ) | const

Definition at line 136 of file tensor.h.

## operator-() [1/2]

tensor_basic< T > operator-

Definition at line 110 of file tensor.cc.

## operator+() [2/2]

tensor_basic< T > operator+ | ( | const tensor_basic< T > & | b | ) | const

Definition at line 121 of file tensor.cc.

## operator-() [2/2]

tensor_basic< T > operator- | ( | const tensor_basic< T > & | b | ) | const

Definition at line 132 of file tensor.cc.

## operator*() [1/3]

tensor_basic< T > operator* | ( | const tensor_basic< T > & | b | ) | const

Definition at line 270 of file tensor.cc.

## operator*() [2/3]

tensor_basic< T > operator* | ( | const T & | k | ) | const

Definition at line 143 of file tensor.cc.

## operator/()

tensor_basic< T > operator/ | ( | const T & | k | ) | const

Definition at line 360 of file tensor.h.

## operator*() [3/3]

point_basic< T > operator* | ( | const point_basic< T > & | x | ) | const

Definition at line 153 of file tensor.cc.

## trans_mult()

point_basic< T > trans_mult | ( | const point_basic< T > & | x | ) | const

Definition at line 367 of file tensor.h.

## operator+=()

tensor_basic< T > & operator+= | ( | const tensor_basic< T > & | b | ) |

Definition at line 174 of file tensor.cc.

## operator-=()

tensor_basic< T > & operator-= | ( | const tensor_basic< T > & | b | ) |

Definition at line 183 of file tensor.cc.

## operator*=()

tensor_basic< T > & operator*= | ( | const T & | k | ) |

Definition at line 192 of file tensor.cc.

## operator/=()

tensor_basic< T > & operator/= | ( | const T & | k | ) |

Definition at line 201 of file tensor.cc.

## determinant()

T determinant | ( | size_type | d = `3` | ) | const

Definition at line 288 of file tensor.cc.

## is_symmetric()

bool is_symmetric | ( | size_type | d = `3` | ) | const

Definition at line 351 of file tensor.cc.

## eig() [1/2]

point_basic< T > eig | ( | tensor_basic< T > & | q,
|  | size_t | dim = `3`
| ) |  | const

Definition at line 426 of file tensor.cc.

## eig() [2/2]

point_basic< T > eig | ( | size_t | dim = `3` | ) | const

Definition at line 440 of file tensor.cc.

## svd()

point_basic< T > svd | ( | tensor_basic< T > & | u,
|  | tensor_basic< T > & | v,
|  | size_t | dim = `3`
| ) |  | const

Definition at line 470 of file tensor.cc.

## Member Data Documentation

## _x

T _x[3][3]

Definition at line 175 of file tensor.h.

The documentation for this class was generated from the following files:

- /build/rheolef-bzr82u/rheolef-7.1/fem/geo_element/tensor.h
- /build/rheolef-bzr82u/rheolef-7.1/fem/geo_element/tensor.cc